︠9cbb8527-8c7c-405b-a92b-d8606c425480i︠
%html
<h1><center>One Line Attack</center></h1>


︡85fa0927-b05d-4435-9cd0-011980cab84e︡{"done":true,"html":"<h1><center>One Line Attack</center></h1>"}
︠f32bd812-70b8-4b3c-9135-c0f739d99608i︠
%md
<b>Description.</b> This attack will compute one of the primes in a composite number if the difference of the primes is small
︡2e755184-6904-47bd-a7d6-44df24b2826e︡{"done":true,"md":"<b>Description.</b> This attack will compute one of the primes in a composite number if the difference of the primes is small"}
︠65a7f22b-3aa2-4c13-a2f4-d2963ecbc614s︠
##############################################################################################
# isquare detectes weither a number is a perfect square or not                               #
##############################################################################################
def isquare (n):
    if isqrt(n) ** 2 == n:
        return(True)
    return(False)


##############################################################################################
# isqrt takes in an integer as input and produces the floor of the square root of the number#
##############################################################################################
def isqrt(n):
    return int(floor(sqrt(n)))

##############################################################################################
# usqrt takes in a number and produces the celing of the square root of the number           #
##############################################################################################
def usqrt (n):
    ur = isqrt(n)
    if ur ** 2 < n:
        ur = ur + 1
    return(ur)

##############################################################################################
# OneLine will take in a composite nubmer and a round limit and attempt to compute one of the# 
#prime factors. If unable the function will print out that no factors have been found        #
##############################################################################################

def OneLine (n, iter):
    for x in range(1, iter + 1):
        sq = usqrt(x * n)
        y = sq ** 2 % n
        if isquare(y) == True:
            t = isqrt(y)
            u = gcd(n, sq - t)
            print("Factor found in round {0} rounds".format(x))
            return(u)
    print("No factors found")
︡9313620e-011a-4f02-a277-8627c55b5e75︡{"done":true}︡
︠73c017fe-541e-43be-b797-a4d2d973ee59︠
%md 
<b>Example.</b> One case where the attack runs of reletivley small numbers
︡c05042cd-6c59-4ed0-9eec-488a8269ac34︡{"done":true,"md":"<b>Example.</b> One case where the attack runs of reletivley small numbers"}
︠74ef9369-6455-4949-aed1-d32fb8d65276s︠

OneLine(next_prime(113)*next_prime(129),100)
︡fbc75acc-41eb-471c-ae8c-a6e97844f9df︡{"stdout":"Factor found in round 1 rounds\n127\n"}︡{"done":true}︡
︠0199bfbd-33bc-46df-b3b8-b1fddc9f10afi︠
%md 
<b>Example.</b> Another example where the attack is running with larger and more seperated primes
︡d6f994d2-5c78-498f-91e6-7b576e65bbb7︡{"done":true,"md":"<b>Example.</b> Another example where the attack is running with larger and more seperated primes"}
︠0ec9e09d-d8b8-492c-b05c-3ff37a7bb6e8s︠
p = next_prime(12345678234567812345678234567)
q = next_prime(12345678234567813786785845456)
p
q
n = p*q
OneLine(n,1000000)
︡ff47e011-b930-4b0c-91b7-a4fcf7ecce3b︡{"stdout":"12345678234567812345678234591\n"}︡{"stdout":"12345678234567813786785845649\n"}︡{"stdout":"Factor found in round 1 rounds\n12345678234567812345678234591\n"}︡{"done":true}︡
︠6de7b5f5-4e14-4c5f-90c5-73255cee6907s︠
︡dd8f6216-2ef5-4a1e-80d6-ef43a66fc31d︡{"done":true}︡
︠af5952e0-5c04-4cdb-940d-b40aed3a4facs︠

︡0563ead9-eafe-484c-907f-1055f029e70e︡{"done":true}︡
︠f3d6a0f1-4e35-4dcb-9850-6bdc2002e7d1︠









